// IICSetupSheet.cpp : implementation file
//

#include "stdafx.h"
#include "PlugIIC.h"
#include "IICSetupSheet.h"
#include "htmlhelp.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "BusData.h"

extern CBPOParamters *pBPOParameters;
/////////////////////////////////////////////////////////////////////////////
// CIICSetupSheet
extern CString usedCode;
extern unsigned short machinevid ;
extern unsigned short machinepid;
extern char machineSN[50];
extern CString MessageStringTable(UINT ID);
extern bool CreateAndOpenRegister(CString strSn,CString key);
extern PLUGINSTATUS pluginstatus;
IMPLEMENT_DYNAMIC(CIICSetupSheet, CPropertySheet)

CIICSetupSheet::CIICSetupSheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	m_psh.dwFlags |= PSP_USEHICON;
	m_psh.dwFlags &= ~PSH_HASHELP;
	UINT ID1,ID2,ID3,ID4,ID5;
	switch(pBPOParameters->m_nLanguage)
	{		
	case 1:
		ID1=IDD_IIC_SETUP_SI; 
		ID2=IDD_IIC_TIME_SI;
		ID3=IDD_PACKETITEM_SI;
		ID4=IDD_IIC_CHECK_ANSWERCODE_SI;
		ID5=IDD_IIC_RULECUSTOMIZE_SI;
		break;
	case 2:
		ID1=IDD_IIC_SETUP_TR; 
		ID2=IDD_IIC_TIME_TR;
		ID3=IDD_PACKETITEM_TR;
		ID4=IDD_IIC_CHECK_ANSWERCODE_TR;
		ID5=IDD_IIC_RULECUSTOMIZE_TR;
		break;
	case 3:
		ID1=IDD_IIC_SETUP; 
		ID2=IDD_IIC_TIME;
		ID3=IDD_PACKETITEM;
		ID4=IDD_IIC_CHECK_ANSWERCODE;
		ID5=IDD_IIC_RULECUSTOMIZE;
		break;
	default:
		ID1=IDD_IIC_SETUP; 
		ID2=IDD_IIC_TIME;
		ID3=IDD_PACKETITEM;
		ID4=IDD_IIC_CHECK_ANSWERCODE;
		ID5=IDD_IIC_RULECUSTOMIZE;
		break;
	}

	m_PageIICSetup = new CIICSetupPage1(ID1);
	m_TimePage      =new CTimePage(ID2);
	m_PagePacketItem=new CPacketItemPage(ID3);
	m_PageCheckAnswer=new CCheckAnswerPage2(ID4);
	m_RuleCustizePage=new CIICRuleCustizePage(ID5);
	AddPage(m_PageIICSetup);
	AddPage(m_TimePage);
	AddPage(m_PagePacketItem);
	AddPage(m_RuleCustizePage);
	AddPage(m_PageCheckAnswer);
	SetActivePage(m_PageIICSetup);
	
}

CIICSetupSheet::CIICSetupSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_psh.dwFlags |= PSP_USEHICON;
	m_psh.dwFlags &= ~PSH_HASHELP;
	UINT ID1,ID2,ID3,ID4,ID5;
	switch(pBPOParameters->m_nLanguage)
	{		
	case 1:
		ID1=IDD_IIC_SETUP_SI; 
		ID2=IDD_IIC_TIME_SI;
		ID3=IDD_PACKETITEM_SI;
		ID4=IDD_IIC_CHECK_ANSWERCODE_SI;
		ID5=IDD_IIC_RULECUSTOMIZE_SI;
		break;
	case 2:
		ID1=IDD_IIC_SETUP_TR; 
		ID2=IDD_IIC_TIME_TR;
		ID3=IDD_PACKETITEM_TR;
		ID4=IDD_IIC_CHECK_ANSWERCODE_TR;
		ID5=IDD_IIC_RULECUSTOMIZE_TR;
		break;
	case 3:
		ID1=IDD_IIC_SETUP; 
		ID2=IDD_IIC_TIME;
		ID3=IDD_PACKETITEM;
		ID4=IDD_IIC_CHECK_ANSWERCODE;
		ID5=IDD_IIC_RULECUSTOMIZE;
		break;
	default:
		ID1=IDD_IIC_SETUP; 
		ID2=IDD_IIC_TIME;
		ID3=IDD_PACKETITEM;
		ID4=IDD_IIC_CHECK_ANSWERCODE;
		ID5=IDD_IIC_RULECUSTOMIZE;
		break;
	}

	m_PageIICSetup = new CIICSetupPage1(ID1);
	m_TimePage      =new CTimePage(ID2);
	m_PagePacketItem=new CPacketItemPage(ID3);
	m_PageCheckAnswer=new CCheckAnswerPage2(ID4);
	m_RuleCustizePage=new CIICRuleCustizePage(ID5);
	AddPage(m_PageIICSetup);
	AddPage(m_TimePage);
	AddPage(m_PagePacketItem);
	AddPage(m_RuleCustizePage);
	AddPage(m_PageCheckAnswer);
	SetActivePage(m_PageIICSetup);

}

CIICSetupSheet::~CIICSetupSheet()
{
	if(m_PageIICSetup != NULL) delete m_PageIICSetup;
	if(m_TimePage != NULL) delete m_TimePage;
	if(m_PageCheckAnswer != NULL) delete m_PageCheckAnswer;
	if(m_PagePacketItem != NULL) delete m_PagePacketItem;
	if(m_RuleCustizePage != NULL) delete m_RuleCustizePage;
}


BEGIN_MESSAGE_MAP(CIICSetupSheet, CPropertySheet)
	//{{AFX_MSG_MAP(CIICSetupSheet)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_APPLY_NOW, OnDefault)
	ON_BN_CLICKED(IDHELP, OnHelp)
	ON_BN_CLICKED(IDOK, OnOK)
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CIICSetupSheet message handlers

BOOL CIICSetupSheet::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	
	// TODO: Add your specialized code here
		CWnd *pWnd=NULL;
	CString str3;
	pWnd = GetDlgItem(IDOK);
	str3=MessageStringTable(IDS_SHEETOK_EN);
	pWnd->SetWindowText(str3);

	pWnd = GetDlgItem(IDCANCEL);
	str3=MessageStringTable(IDS_SHEET_CANCEL_EN);
	pWnd->SetWindowText(str3);

	pWnd = GetDlgItem(IDHELP);
	str3=MessageStringTable(IDS_SHEET_HELP_EN);
	pWnd->SetWindowText(str3);

	pWnd = GetDlgItem(ID_APPLY_NOW);
	str3=MessageStringTable(IDS_SHEET_DEFAULT_EN);
	pWnd->SetWindowText(str3);	
	pWnd->EnableWindow();

		if (!pluginstatus.bReg&&(!pluginstatus.bFree))
	{
		UpdateOkText();
	}
	return bResult;
}

bool CIICSetupSheet::UpdateOkText()
{
	CString str3;
		CWnd *pWnd = GetDlgItem(IDOK);
	str3=MessageStringTable(IDS_REGISTER_EN);
		pWnd->SetWindowText(str3);
	return true;
}
void CIICSetupSheet::OnDefault()
{
	GetActivePage()->UpdateData(TRUE);

	if(GetActiveIndex() == 4)
		m_PageCheckAnswer->DefaultValue();
	else if(GetActiveIndex() == 1)
	{
		 m_TimePage->DefaultCheck();
		 m_TimePage->DefaultEdit();
	}
	else if(GetActiveIndex() == 0)
		m_PageIICSetup->DefaultValue();
	else if(GetActiveIndex() == 2)
	{
		m_PagePacketItem->DefaultColor();
		m_PagePacketItem->DefaultCheck();
	}
	else if(GetActiveIndex() ==3)
		m_RuleCustizePage->DefaultValue();
}
void CIICSetupSheet::OnHelp()
{
	CString				szCurPath("");
	CString				strPath("");
	
	GetModuleFileName(NULL,szCurPath.GetBuffer(MAX_PATH),MAX_PATH);
	szCurPath.ReleaseBuffer();
	strPath = szCurPath.Left(szCurPath.ReverseFind('\\') + 1);
	switch(pBPOParameters->m_nLanguage)
	{
	case 0://english
		strPath += "//Help//Eng//";
		break;
	case 1://chinese Si
		strPath += "//Help/Si//";
		break;
	case 2://chinses Tr
		strPath += "//Help/Tr//";
		break;
	default:
		strPath += "//Help/Eng//";
		break;
	}
	strPath += "LogicAnalyzer.chm";
 	if(pBPOParameters->m_nLanguage == 3)
	{
		strPath += "::/Introduction to Logic Analysis/IIC Analysis/IIC Analysis.htm";
	}
	else
	{
		strPath += "::/Seting/SpecBus.htm";
	}
	HtmlHelp(m_hWnd, strPath, HH_DISPLAY_TOPIC,0);

}
void CIICSetupSheet::OnOK()
{
	CPlugIICApp*		   pApp=(CPlugIICApp*)::AfxGetApp();
	//save page1
	if (m_PageIICSetup->m_bActive)
	{
		if(!m_PageIICSetup->StoreSelectChannel())
			return;
		m_PageIICSetup->StoreColor();
		m_PageIICSetup->StoreBus();
		
	}
	if(m_TimePage->m_bActive)
	{
		m_TimePage->SaveCheck();
		if(0 == m_TimePage->SaveEdit())
		{
			AfxMessageBox(MessageStringTable(IDS_TIMEERROR0_EN));
			return;
		}
		if(-1 == m_TimePage->SaveEdit())
		{
			AfxMessageBox(MessageStringTable(IDS_TIMEERROR0_EN));
			return;
		}
	}
	if (m_PagePacketItem->m_bActive)
	{
		m_PagePacketItem->StoreColor();
		m_PagePacketItem->StoreCheckStatus();
	}
	if (m_RuleCustizePage->m_bActive)
	{	
		m_RuleCustizePage->StoreDATA();
	}
	EndDialog(IDOK);
}


