// MSParamters.h: interface for the CMSParamters class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSPARAMTERS_H__2B408933_F7AF_436D_8FBC_2BE9F4E2E20F__INCLUDED_)
#define AFX_MSPARAMTERS_H__2B408933_F7AF_436D_8FBC_2BE9F4E2E20F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <vector>
using  std::vector;
class CMSParamters  
{
public:
	CMSParamters();
	virtual ~CMSParamters();
	vector<int>		m_objMSStartAry;		// Save the array of the Satrt Ary Flag, eg:start_R. 
	vector<int>		m_objMSAddressAry;	//Save the array of the Address Ary Flag, such as Address4,Address7 and Address8.
	vector<int>		m_objMSReadAry;		//Save the array of the Read Ary Flag, eg:Read_Reg,Read_Pec...
	vector<int>		m_objMSWriteAry;	//Save the array of the Write Ary Flag, eg:Write_Reg,Write_Pec...
	vector<int>		m_objMSDataAry;		//Save the array of the Data Ary Flag, eg:Data1,data2...

	void			FreeArray();

	vector<int>		m_objMSUniteAry1;		//Integrate the Flag Segment.
	int				m_nFLagSegment1;	//If there are many segments to be integrated, it will use the flags among them to identify. 
										//For example: 0xFFFFFFF.

	vector<int>		m_objMSUniteAry2;		//Integrate Flag Segment.
	int				m_nFLagSegment2;	//If there are many segments to be integrated, it will use the flag to identify among them. 
										//For example: 0xFFFFFFF.

	//reserver
	vector<int>		m_objMSReserveAry;
	int				m_nReserve1;	
	//Description: "0~39" indicates that draw the table according to the Address, all of them should be drew.
	//"40~100" indicates that analyze the current signal. draw the table according to the signal, the others can be represented by the elliptical line. 
	//"1" represents the type of the I2c 24L and the address_h,L; "2" represents the multi-device, SCCB; "3" represents the Multi-Sector, CF.
	//"40" represents the multi-page, ssk9, "41" represents the I2C.
	int				m_nReserve2;	//"2" indicates that the reg address is activated, or it indicates that the reg address is not activated.
	unsigned int	m_uReserve1;
	unsigned int	m_uReserve2;
	bool			m_bReserve1;
	bool			m_bReserve2;
	double			m_dReserve1;
	double			m_dReserve2;
	CString			m_strReserve1;	
	CString			m_strReserve2;
};

#endif // !defined(AFX_MSPARAMTERS_H__2B408933_F7AF_436D_8FBC_2BE9F4E2E20F__INCLUDED_)
