// PacketItemPage.cpp : implementation file
//

#include "stdafx.h"
#include "PlugIIC.h"
#include "PacketItemPage.h"
#include "BusData.h"
#include "IICSetupSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEFAULT_ADDRESS_COLOR		RGB(249,114,29)
#define DEFAULT_READ_COLOR			RGB(60,125,253)
#define DEFAULT_ADDRESSACK_COLOR	RGB(255,0,128)
#define DEFAULT_ADDRESSNACK_COLOR	RGB(249,117,142)
#define DAFAULT_DATA_COLOR			RGB(51,204,51)
#define DEFAULT_DATAACK_COLOR		RGB(138,206,137)
#define DEFAULT_DATANACK_COLOR		RGB(171,203,95)

#define DEFAULT_DESRIBE_COLOR		RGB(5,5,255)
#define DEFAULT_WRITE_COLOR			RGB(230,73,89)
/////////////////////////////////////////////////////////////////////////////
// CPacketItemPage property page
extern PLUGINSTATUS pluginstatus;
extern PLUGINBUSLIST buslist[9];
IMPLEMENT_DYNCREATE(CPacketItemPage, CPropertyPage)

CPacketItemPage::CPacketItemPage() : CPropertyPage(CPacketItemPage::IDD)
{
	//{{AFX_DATA_INIT(CPacketItemPage)
	m_bcAddress = FALSE;
	m_bcRead = FALSE;
	m_bcAddressAck = FALSE;
	m_bcPackData = FALSE;
	m_bcPackDataAck = FALSE;
	m_bcPackDescribe = FALSE;
	m_bcPackWrite= FALSE;
	m_bcAddressNack=FALSE;
	m_bcPackDataNack=FALSE;
	m_bcREGADDR=FALSE;
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;	
	m_bActive=false;
}

CPacketItemPage::CPacketItemPage( UINT IDD, UINT nIDCaption): CPropertyPage(IDD)
{
	//{{AFX_DATA_INIT(CIICSetupPage1)
	m_bcAddress = FALSE;
	m_bcRead = FALSE;
	m_bcAddressAck = FALSE;
	m_bcPackData = FALSE;
	m_bcPackDataAck = FALSE;
	m_bcPackDescribe = FALSE;
	m_bcPackWrite= FALSE;
	m_bcAddressNack=FALSE;
	m_bcPackDataNack=FALSE;
	m_bcREGADDR=FALSE;
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;	
	m_bActive=false;
	
}
CPacketItemPage::~CPacketItemPage()
{
}

void CPacketItemPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPacketItemPage)
	DDX_Control(pDX, IDC_PACKET_CLR_DESCRIBE, m_Describe);
	DDX_Control(pDX, IDC_PACKET_CLR_DATAACK, m_clrbtnDataAck);
	DDX_Control(pDX, IDC_PACKET_CLR_DATA, m_clrbtnData);
	DDX_Control(pDX, IDC_PACKET_CLR_ADDACK, m_clrbtnAddressAck);
	DDX_Control(pDX, IDC_PACKET_CLR_READ, m_clrbtnRead);
	DDX_Control(pDX, IDC_PACKET_CLR_WRITE, m_clrbtnWrite);	
	DDX_Control(pDX, IDC_PACKET_CLR_ADDRESS, m_clrbtnAddress);
	DDX_Control(pDX, IDC_PACKET_CLR_ADDNACK, m_clrbtnAddressNack);
	DDX_Control(pDX, IDC_PACKET_CLR_DATANACK, m_clrbtnDataNack);
	DDX_Control(pDX, IDC_PACKET_CLR_REGADDR, m_clrbtnREGADDR);
    DDX_Check(pDX, IDC_CHECK_REGADDR, m_bcREGADDR);
	DDX_Check(pDX, IDC_CHECK_PACKADDRESS, m_bcAddress);
	DDX_Check(pDX, IDC_CHECK_PACKREAD, m_bcRead);
	DDX_Check(pDX, IDC_CHECK_PACKWRITE, m_bcPackWrite);	
	DDX_Check(pDX, IDC_CHECK_PACKADDRESSACK, m_bcAddressAck);
	DDX_Check(pDX, IDC_CHECK_PACKDATA, m_bcPackData);
	DDX_Check(pDX, IDC_CHECK_PACKDATAACK, m_bcPackDataAck);
	DDX_Check(pDX, IDC_CHECK_PACKDESCRIBE, m_bcPackDescribe);
	DDX_Check(pDX, IDC_CHECK_PACKADDRESSNACK, m_bcAddressNack);
	DDX_Check(pDX, IDC_CHECK_PACKDATANACK, m_bcPackDataNack);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPacketItemPage, CPropertyPage)
	//{{AFX_MSG_MAP(CPacketItemPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CPacketItemPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	InitParameter();
	m_bActive=true;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPacketItemPage::InitParameter()
{

	m_clrbtnAddress.SetFaceColor(buslist[0].clr);
	m_clrbtnRead.SetFaceColor(buslist[1].clr);
	m_clrbtnAddressAck.SetFaceColor(buslist[2].clr);
	m_clrbtnData.SetFaceColor(buslist[3].clr);
	m_clrbtnDataAck.SetFaceColor(buslist[4].clr);
	m_Describe.SetFaceColor(buslist[8].clr);
	m_clrbtnWrite.SetFaceColor(buslist[5].clr);

	m_clrbtnAddressNack.SetFaceColor(buslist[6].clr);
	m_clrbtnDataNack.SetFaceColor(buslist[7].clr);

    m_clrbtnREGADDR.SetFaceColor(buslist[9].clr);
    m_bcREGADDR=buslist[9].bShow;
	m_bcAddress=buslist[0].bShow;
	m_bcRead=buslist[1].bShow;
	m_bcAddressAck=buslist[2].bShow;
	m_bcPackData=buslist[3].bShow;
	m_bcPackDataAck=buslist[4].bShow;
	m_bcPackDescribe=buslist[8].bShow;
	m_bcPackWrite=buslist[5].bShow;

	m_bcAddressNack=buslist[6].bShow;;
	m_bcPackDataNack=buslist[7].bShow;

	UpdateData(false);
}

void CPacketItemPage::StoreColor()
{
	COLORREF	clrDes=m_Describe.GetFaceColor();
	COLORREF	clrDataAck=m_clrbtnDataAck.GetFaceColor();
	COLORREF	clrData=m_clrbtnData.GetFaceColor();
	COLORREF	clrAddressAck=m_clrbtnAddressAck.GetFaceColor();
	COLORREF	clrRead=m_clrbtnRead.GetFaceColor();
	COLORREF	clrAddress=m_clrbtnAddress.GetFaceColor();
	COLORREF	clrWrite=m_clrbtnWrite.GetFaceColor();

	buslist[0].clr=clrAddress;
	buslist[1].clr=clrRead;
	buslist[2].clr=clrAddressAck;
	buslist[3].clr=clrData;
	buslist[4].clr=clrDataAck;
	buslist[5].clr=clrWrite;
	buslist[6].clr=m_clrbtnAddressNack.GetFaceColor();
	buslist[7].clr=m_clrbtnDataNack.GetFaceColor();
	buslist[8].clr=clrDes;
	buslist[9].clr=m_clrbtnREGADDR.GetFaceColor();
}
void CPacketItemPage::StoreCheckStatus()
{
	UpdateData(true);
	buslist[0].bShow=m_bcAddress;
	buslist[1].bShow=m_bcRead;
	buslist[2].bShow=m_bcAddressAck;
	buslist[3].bShow=m_bcPackData;
	buslist[4].bShow=m_bcPackDataAck;
	buslist[8].bShow=m_bcPackDescribe;
	buslist[5].bShow=m_bcPackWrite;

	buslist[6].bShow=m_bcAddressNack;
	buslist[7].bShow=m_bcPackDataNack;
	buslist[9].bShow=m_bcREGADDR;
}
/////////////////////////////////////////////////////////////////////////////
// CPacketItemPage message handlers

void CPacketItemPage::DefaultColor()
{
	COLORREF clrAdd  = DEFAULT_ADDRESS_COLOR;
	COLORREF clrRead = DEFAULT_READ_COLOR;
	COLORREF clrSck = DEFAULT_ADDRESSACK_COLOR;
	COLORREF clrData =DAFAULT_DATA_COLOR ;
	COLORREF clrDataAck =DEFAULT_DATAACK_COLOR ;
	COLORREF clrDesribe = DEFAULT_DESRIBE_COLOR;
	COLORREF clrWrite = DEFAULT_WRITE_COLOR;

	m_clrbtnAddress.SetFaceColor(clrAdd);
	m_clrbtnRead.SetFaceColor(clrRead);
	m_clrbtnAddressAck.SetFaceColor(clrSck);
	m_clrbtnData.SetFaceColor(clrData);
	m_clrbtnDataAck.SetFaceColor(clrDataAck);
	m_Describe.SetFaceColor(clrDesribe);
	m_clrbtnWrite.SetFaceColor(clrWrite);
    m_clrbtnREGADDR.SetFaceColor(RGB(43,207,255));
	m_clrbtnREGADDR.ReDrawButton();
	m_clrbtnAddress.ReDrawButton();
	m_clrbtnRead.ReDrawButton();
	m_clrbtnAddressAck.ReDrawButton();
	m_clrbtnData.ReDrawButton();
	m_clrbtnDataAck.ReDrawButton();
	m_Describe.ReDrawButton();
	m_clrbtnWrite.ReDrawButton();

	//lupy 20081007
	m_clrbtnAddressNack.SetFaceColor(DEFAULT_ADDRESSNACK_COLOR);
	m_clrbtnAddressNack.ReDrawButton();

	m_clrbtnDataNack.SetFaceColor(DEFAULT_DATANACK_COLOR);
	m_clrbtnDataNack.ReDrawButton();


}
void CPacketItemPage::DefaultCheck()
{

	m_bcAddress=TRUE;
	m_bcRead=TRUE;
	m_bcAddressAck=TRUE;
	m_bcPackData=TRUE;
	m_bcPackDataAck=TRUE;
	m_bcPackDescribe=TRUE;
	m_bcPackWrite=TRUE;
	m_bcAddressNack=TRUE;
	m_bcPackDataNack=TRUE;
	m_bcREGADDR=TRUE;
	UpdateData(FALSE);
}
