// TimePage.cpp : implementation file
//

#include "stdafx.h"
#include "PlugIIC.h"
#include "TimePage.h"
#include "IIC_PARAM_DATA.h" //iic paramters
#include "IICSetupSheet.h"
#include "BusData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimePage property page

extern IICPARAM iicparamdata;
extern PLUGINSTATUS pluginstatus;

IMPLEMENT_DYNCREATE(CTimePage, CPropertyPage)

CTimePage::CTimePage(): CPropertyPage(CTimePage::IDD)
{
	//{{AFX_DATA_INIT(CTimePage)
	m_startuptimebool = FALSE;
	m_thddatbool = FALSE;
	m_thdstabool = FALSE;
	m_tsudatbool = FALSE;	
	m_tsustobool = FALSE;
	//}}AFX_DATA_INIT
	m_psp.dwFlags    |= PSP_HASHELP;	
	m_bActive         =false;
}

CTimePage::CTimePage( UINT IDD, UINT nIDCaption ): CPropertyPage(IDD)
{
	//{{AFX_DATA_INIT(CTimePage)
	m_startuptimebool = FALSE;
	m_thddatbool = FALSE;
	m_thdstabool = FALSE;
	m_tsudatbool = FALSE;
	m_tsustobool = FALSE;
	//}}AFX_DATA_INIT
	m_psp.dwFlags    |= PSP_HASHELP;	
	m_bActive         =false;
}

CTimePage::~CTimePage()
{
}

void CTimePage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimePage)
	DDX_Check(pDX, IDC_CHECK_startuptime, m_startuptimebool);
	DDX_Check(pDX, IDC_CHECK_thddat, m_thddatbool);
	DDX_Check(pDX, IDC_CHECK_thdsta, m_thdstabool);
	DDX_Check(pDX, IDC_CHECK_tsudat, m_tsudatbool);
	DDX_Check(pDX, IDC_CHECK_tsusto, m_tsustobool);
	DDX_Control(pDX, IDC_EDIT_thdstamin, m_EDITthdstamin);
	DDX_Control(pDX, IDC_EDIT_thdstamax, m_EDITthdstamax);
	DDX_Control(pDX, IDC_EDIT_thddatmin, m_EDITthddatmin);
	DDX_Control(pDX, IDC_EDIT_thddatmax, m_EDITthddatmax);
	DDX_Control(pDX, IDC_EDIT_tsustomin, m_EDITtsustomin);
	DDX_Control(pDX, IDC_EDIT_tsustomax, m_EDITtsustomax);
	DDX_Control(pDX, IDC_EDIT_tsudatmin, m_EDITtsudatmin);
	DDX_Control(pDX, IDC_EDIT_tsudatmax, m_EDITtsudatmax);	
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTimePage, CPropertyPage)
	//{{AFX_MSG_MAP(CTimePage)
	ON_BN_CLICKED(IDC_CHECK_startuptime, OnCHECKstartuptime)
	ON_BN_CLICKED(IDC_CHECK_thdsta, OnCHECKthdsta)
	ON_BN_CLICKED(IDC_CHECK_thddat, OnCHECKthddat)
	ON_BN_CLICKED(IDC_CHECK_tsusto, OnCHECKtsusto)
	ON_BN_CLICKED(IDC_CHECK_tsudat, OnCHECKtsudat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimePage message handlers

BOOL CTimePage::OnInitDialog() 
{
	CDialog::OnInitDialog();	
	// TODO: Add extra initialization here
	InitCheck();
	InitEdit();
	InitBitmap();
	m_bActive=true;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTimePage::InitBitmap()
{
	m_oBMP1.LoadBitmap(IDB_BITMAP_TIME);	
	m_oTransparentBitmap1.SubclassDlgItem(IDC_STATIC_TIME, this);
	m_oTransparentBitmap1.Initialize(HBITMAP(m_oBMP1), RGB(255,255,255), 1.0, 1.0);
    m_oTransparentBitmap1.ChangeBitmap(HBITMAP(m_oBMP1));
}

void CTimePage::InitCheck()
{
	m_startuptimebool=iicparamdata.startuptimebool;
	if( m_startuptimebool == TRUE )
	{
		m_thddatbool=iicparamdata.thddatbool;
		if( m_thddatbool == TRUE )
		{
			GetDlgItem(IDC_EDIT_thddatmin)->EnableWindow();
			GetDlgItem(IDC_EDIT_thddatmax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_thddatmin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_thddatmax)->EnableWindow(FALSE);
		}

		m_thdstabool=iicparamdata.thdstabool;
		if( m_thdstabool == TRUE )
		{
			GetDlgItem(IDC_EDIT_thdstamin)->EnableWindow();
			GetDlgItem(IDC_EDIT_thdstamax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_thdstamin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_thdstamax)->EnableWindow(FALSE);
		}
		
		m_tsudatbool=iicparamdata.tsudatbool;
		if( m_tsudatbool == TRUE )
		{
			GetDlgItem(IDC_EDIT_tsudatmin)->EnableWindow();
			GetDlgItem(IDC_EDIT_tsudatmax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_tsudatmin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_tsudatmax)->EnableWindow(FALSE);
		}	
		
		m_tsustobool=iicparamdata.tsustobool;
		if( m_tsustobool == TRUE )
		{
			GetDlgItem(IDC_EDIT_tsustomin)->EnableWindow();
			GetDlgItem(IDC_EDIT_tsustomax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_tsustomin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_tsustomax)->EnableWindow(FALSE);
		}

	}
	else
	{
		m_thddatbool=iicparamdata.thddatbool;
		m_thdstabool=iicparamdata.thdstabool;
		m_tsudatbool=iicparamdata.tsudatbool;	
		m_tsustobool=iicparamdata.tsustobool;
		int a[12]={IDC_CHECK_thdsta,IDC_EDIT_thdstamin,IDC_EDIT_thdstamax,
	           IDC_CHECK_thddat,IDC_EDIT_thddatmin,IDC_EDIT_thddatmax,IDC_CHECK_tsusto,
	           IDC_EDIT_tsustomin,IDC_EDIT_tsustomax,IDC_CHECK_tsudat,IDC_EDIT_tsudatmin,
	           IDC_EDIT_tsudatmax};
	    for(int i = 0 ; i< 12 ; i++ )
			GetDlgItem(a[i])->EnableWindow(FALSE);			
	}
    UpdateData(FALSE);	
}

void CTimePage::InitEdit()
{
	CString str;
	str.Format("%0.2f",iicparamdata.thdstamin);
	GetDlgItem(IDC_EDIT_thdstamin)->SetWindowText(str);
	str.Format("%0.2f",iicparamdata.thdstamax);
	GetDlgItem(IDC_EDIT_thdstamax)->SetWindowText(str);

	str.Format("%0.2f",iicparamdata.thddatmin);
	GetDlgItem(IDC_EDIT_thddatmin)->SetWindowText(str);
	str.Format("%0.2f",iicparamdata.thddatmax);
	GetDlgItem(IDC_EDIT_thddatmax)->SetWindowText(str);

	str.Format("%0.2f",iicparamdata.tsustomin);
	GetDlgItem(IDC_EDIT_tsustomin)->SetWindowText(str);
	str.Format("%0.2f",iicparamdata.tsustomax);
	GetDlgItem(IDC_EDIT_tsustomax)->SetWindowText(str);

	str.Format("%0.2f",iicparamdata.tsudatmin);
	GetDlgItem(IDC_EDIT_tsudatmin)->SetWindowText(str);
	str.Format("%0.2f",iicparamdata.tsudatmax);
	GetDlgItem(IDC_EDIT_tsudatmax)->SetWindowText(str);

}

void CTimePage::DefaultCheck()
{
	m_startuptimebool=false;
	m_thddatbool=true;
	m_thdstabool=true;
	m_tsudatbool=true;
	m_tsustobool=true;
	GetDlgItem(IDC_CHECK_startuptime) ->EnableWindow();
	int a[4]={IDC_CHECK_thdsta,IDC_CHECK_thddat,IDC_CHECK_tsusto,IDC_CHECK_tsudat};
	for(int i = 0 ; i< 4 ; i++ )	
		GetDlgItem(a[i])->EnableWindow(FALSE);
    UpdateData(FALSE);
}

void CTimePage::DefaultEdit()
{	
	int a[8]={IDC_EDIT_thdstamin,IDC_EDIT_thdstamax,IDC_EDIT_thddatmin,IDC_EDIT_thddatmax,
	           IDC_EDIT_tsustomin,IDC_EDIT_tsustomax,IDC_EDIT_tsudatmin,IDC_EDIT_tsudatmax};
	for(int i = 0 ; i< 8 ; i++ )	
		GetDlgItem(a[i])->EnableWindow(FALSE);	
	GetDlgItem(IDC_EDIT_thdstamin)->SetWindowText("0.50");
	GetDlgItem(IDC_EDIT_thdstamax)->SetWindowText("50.00");	
	GetDlgItem(IDC_EDIT_thddatmin)->SetWindowText("0.20");
	GetDlgItem(IDC_EDIT_thddatmax)->SetWindowText("50.00");	
	GetDlgItem(IDC_EDIT_tsustomin)->SetWindowText("0.50");
	GetDlgItem(IDC_EDIT_tsustomax)->SetWindowText("50.00");	
	GetDlgItem(IDC_EDIT_tsudatmin)->SetWindowText("0.20");
	GetDlgItem(IDC_EDIT_tsudatmax)->SetWindowText("50.00");	
}

void CTimePage::SaveCheck()
{
	UpdateData();
	iicparamdata.startuptimebool=m_startuptimebool;
	iicparamdata.thddatbool=m_thddatbool;
	iicparamdata.thdstabool=m_thdstabool;
	iicparamdata.tsudatbool=m_tsudatbool;
	iicparamdata.tsustobool=m_tsustobool;
	
}

double CTimePage::strToDbl(CString str)
{
	double dbl;
	UINT len = 0;
	for(int i = 0;i < str.GetLength();i++)
	{
		if(str.GetAt(i) == '.')
		{
			len = i +1;
			break;
		}
	}
	if(len != 0)
	{
		if((len + 2) <= str.GetLength())
			str = str.Left(len + 2);
	}
	dbl = atof(str);
	return dbl; 
}

CString CTimePage::dblToStr(double dbl) 
{
	CString str;
	str.Format("%f",dbl);
	for(int i = 0;i < str.GetLength();i++)
	{
		if(str.GetAt(i) == '.')
		{
			str = str.Left(i+3);
			break;
		}
	}
	return str;
}

void CTimePage::SetEditValue()
{    
	CString str;
    m_EDITthdstamin.GetWindowText(str);
	m_EDITthdstamin.SetWindowText(dblToStr(strToDbl(str)));	
    m_EDITthdstamax.GetWindowText(str);
	m_EDITthdstamax.SetWindowText(dblToStr(strToDbl(str)));	

	m_EDITthddatmin.GetWindowText(str);
	m_EDITthddatmin.SetWindowText(dblToStr(strToDbl(str)));	
    m_EDITthddatmax.GetWindowText(str);
	m_EDITthddatmax.SetWindowText(dblToStr(strToDbl(str)));		

	m_EDITtsustomin.GetWindowText(str);
	m_EDITtsustomin.SetWindowText(dblToStr(strToDbl(str)));	
    m_EDITtsustomax.GetWindowText(str);
	m_EDITtsustomax.SetWindowText(dblToStr(strToDbl(str)));	

    m_EDITtsudatmin.GetWindowText(str);
	m_EDITtsudatmin.SetWindowText(dblToStr(strToDbl(str)));	
    m_EDITtsudatmax.GetWindowText(str);
	m_EDITtsudatmax.SetWindowText(dblToStr(strToDbl(str)));		
    
}

int CTimePage::SaveEdit()
{
	SetEditValue();
	UpdateData();
	CString str;
    double thdstamin,thdstamax;	
	if( m_startuptimebool )
	{
		if( m_thdstabool )
		{
			GetDlgItem(IDC_EDIT_thdstamin)->GetWindowText(str);
			thdstamin=atof(str);    
			GetDlgItem(IDC_EDIT_thdstamax)->GetWindowText(str);
			thdstamax=atof(str);
			if( !(0.01 <= thdstamin && thdstamin <= 65535) )
			{			
				m_EDITthdstamin.SetFocus();
				m_EDITthdstamin.SetSel(0,-1); 
				return 0;
			}
			if( !(0.01 <= thdstamax && thdstamax <= 65535) )
			{			
				m_EDITthdstamax.SetFocus();
				m_EDITthdstamax.SetSel(0,-1); 
				return 0;
			}
			if( thdstamin >= thdstamax )
			{
				m_EDITthdstamin.SetFocus();
				m_EDITthdstamin.SetSel(0,-1);	
				return -1;
			}
		}
		
		double thddatmin,thddatmax;
		if( m_thddatbool )
		{		
			GetDlgItem(IDC_EDIT_thddatmin)->GetWindowText(str);
			thddatmin=atof(str);    
			GetDlgItem(IDC_EDIT_thddatmax)->GetWindowText(str);
			thddatmax=atof(str);
			if( !(0.01 <= thddatmin && thddatmin <= 65535) )
			{			
				m_EDITthddatmin.SetFocus();
				m_EDITthddatmin.SetSel(0,-1); 
				return 0;
			}
			if( !(0.01 <= thddatmax && thddatmax <= 65535) )
			{			
				m_EDITthddatmax.SetFocus();
				m_EDITthddatmax.SetSel(0,-1); 
				return 0;
			}
			if( thddatmin >= thddatmax )
			{
				m_EDITthddatmin.SetFocus();
				m_EDITthddatmin.SetSel(0,-1);
				return -1;	
			}
		}
		
		double tsustomin,tsustomax;
		if( m_tsustobool )
		{
			GetDlgItem(IDC_EDIT_tsustomin)->GetWindowText(str);
			tsustomin=atof(str);    
			GetDlgItem(IDC_EDIT_tsustomax)->GetWindowText(str);
			tsustomax=atof(str);
			if( !(0.01 <= tsustomin && tsustomin <= 65535) )
			{
				m_EDITtsustomin.SetFocus();
				m_EDITtsustomin.SetSel(0,-1);
				return 0;
			}
			if( !(0.01 <= tsustomax && tsustomax <= 65535) )
			{
				m_EDITtsustomax.SetFocus();
				m_EDITtsustomax.SetSel(0,-1);
				return 0;
			}
			if( tsustomin >= tsustomax )
			{
				m_EDITtsustomin.SetFocus();
				m_EDITtsustomin.SetSel(0,-1);
				return -1;
			}
		}
		
		double tsudatmin,tsudatmax;
		if( m_tsudatbool )
		{		
			GetDlgItem(IDC_EDIT_tsudatmin)->GetWindowText(str);
			tsudatmin=atof(str);    
			GetDlgItem(IDC_EDIT_tsudatmax)->GetWindowText(str);
			tsudatmax=atof(str);
			if( !(0.01 <= tsudatmin && tsudatmin <= 65535) )
			{
				m_EDITtsudatmin.SetFocus();
				m_EDITtsudatmin.SetSel(0,-1);
				return 0;
			}
			if( !(0.01 <= tsudatmax && tsudatmax <= 65535) )
			{
				m_EDITtsudatmax.SetFocus();
				m_EDITtsudatmax.SetSel(0,-1);
				return 0;
			}
			if( tsudatmin >= tsudatmax )
			{
				m_EDITtsudatmin.SetFocus();
				m_EDITtsudatmin.SetSel(0,-1);
				return -1;	
			}
		}
		
		if( m_thdstabool )
		{
			iicparamdata.thdstamin=thdstamin;
			iicparamdata.thdstamax=thdstamax;
		}
		
		if( m_thddatbool )
		{
			iicparamdata.thddatmin=thddatmin;
			iicparamdata.thddatmax=thddatmax;
		}
		
		if( m_tsustobool )
		{
			iicparamdata.tsustomin=tsustomin;
			iicparamdata.tsustomax=tsustomax;
		}
		
		if( m_tsudatbool )
		{
			iicparamdata.tsudatmin=tsudatmin;
			iicparamdata.tsudatmax=tsudatmax;
		}
	}
	return 1;
}

void CTimePage::OnCHECKstartuptime() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_startuptimebool)
	{	
		GetDlgItem(IDC_CHECK_thdsta)  ->EnableWindow();	
		GetDlgItem(IDC_CHECK_thddat)  ->EnableWindow();		
		GetDlgItem(IDC_CHECK_tsusto)  ->EnableWindow();		
		GetDlgItem(IDC_CHECK_tsudat)  ->EnableWindow();			
		if( m_thddatbool == TRUE )
		{
			GetDlgItem(IDC_EDIT_thddatmin)->EnableWindow();
			GetDlgItem(IDC_EDIT_thddatmax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_thddatmin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_thddatmax)->EnableWindow(FALSE);
		}
		
		if( m_thdstabool == TRUE )
		{
			GetDlgItem(IDC_EDIT_thdstamin)->EnableWindow();
			GetDlgItem(IDC_EDIT_thdstamax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_thdstamin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_thdstamax)->EnableWindow(FALSE);
		}		
		
		if( m_tsudatbool == TRUE )
		{
			GetDlgItem(IDC_EDIT_tsudatmin)->EnableWindow();
			GetDlgItem(IDC_EDIT_tsudatmax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_tsudatmin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_tsudatmax)->EnableWindow(FALSE);
		}	
		
		if( m_tsustobool == TRUE )
		{
			GetDlgItem(IDC_EDIT_tsustomin)->EnableWindow();
			GetDlgItem(IDC_EDIT_tsustomax)->EnableWindow();
		}
		else
		{
			GetDlgItem(IDC_EDIT_tsustomin)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_tsustomax)->EnableWindow(FALSE);
		}
		UpdateData(FALSE);
	}
	else
	{
		int a[12]={IDC_CHECK_thdsta,IDC_EDIT_thdstamin,IDC_EDIT_thdstamax,
	           IDC_CHECK_thddat,IDC_EDIT_thddatmin,IDC_EDIT_thddatmax,IDC_CHECK_tsusto,
	           IDC_EDIT_tsustomin,IDC_EDIT_tsustomax,IDC_CHECK_tsudat,IDC_EDIT_tsudatmin,
	           IDC_EDIT_tsudatmax};
	    for(int i = 0 ; i< 12 ; i++ )
			GetDlgItem(a[i])->EnableWindow(FALSE);	
	}
}

void CTimePage::OnCHECKthdsta() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if( m_thdstabool )
	{
		GetDlgItem(IDC_EDIT_thdstamin)->EnableWindow();
		GetDlgItem(IDC_EDIT_thdstamax)->EnableWindow();
	}
	else
	{
		GetDlgItem(IDC_EDIT_thdstamin)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_thdstamax)->EnableWindow(FALSE);
	}
}

void CTimePage::OnCHECKthddat() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if( m_thddatbool )
	{
		GetDlgItem(IDC_EDIT_thddatmin)->EnableWindow();
		GetDlgItem(IDC_EDIT_thddatmax)->EnableWindow();
	}
	else
	{
		GetDlgItem(IDC_EDIT_thddatmin)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_thddatmax)->EnableWindow(FALSE);
	}
}

void CTimePage::OnCHECKtsusto() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if( m_tsustobool )
	{
		GetDlgItem(IDC_EDIT_tsustomin)->EnableWindow();
		GetDlgItem(IDC_EDIT_tsustomax)->EnableWindow();
	}
	else
	{
		GetDlgItem(IDC_EDIT_tsustomin)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_tsustomax)->EnableWindow(FALSE);
	}
}

void CTimePage::OnCHECKtsudat() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if( m_tsudatbool )
	{
		GetDlgItem(IDC_EDIT_tsudatmin)->EnableWindow();
		GetDlgItem(IDC_EDIT_tsudatmax)->EnableWindow();
	}
	else
	{
		GetDlgItem(IDC_EDIT_tsudatmin)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_tsudatmax)->EnableWindow(FALSE);
	}
}
