// BusDataArray.h: interface for the CBusDataArray class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PLUGIN_BUSDATA_ARY
#define PLUGIN_BUSDATA_ARY

class CBusDataArray  //Set and get the each type of wavform in display place 
{
public:
	CBusDataArray();
	virtual ~CBusDataArray();
	
public:
	CArray<unsigned int,unsigned int>m_aryBusAddress;
	CArray<__int64,__int64>m_aryBusData;
	CArray<short,short>m_aryBusFlag;
	CArray<COLORREF,COLORREF>m_aryBusClr;
	unsigned short        m_uPid;

private:
	bool				RemoveBusPosByAry(int nAryIndex); // According to the Bus Array Index to Delete the Pos value of Bus 
	bool				RemoveBusDataByAry(int nAryIndex);//According to the Bus Array Index to Delete the Data value of Bus 
	bool				RemoveBusFlagByAry(int nAryIndex);//According to the Bus Array Index to Delete the Flag value of Bus 
	bool				RemoveBusClrByAry(int nAryIndex); //According to the Bus Array Index to Delete the Clr value of Bus 
	bool				Overflow();                       // Over flow information cue 

public:
	int		Add(unsigned int nAddress,__int64 nValue,short nFlag,COLORREF clr);// Add one unit
	bool	Delete(int nAryPos);// Delete address,data,Flag and BusClr through the array 
	bool	Read(int nAryPos,unsigned int &nPos,__int64 &nData,short &nFlag,COLORREF &clr);     //Read the value of POS,DATA,FLAG and COLOR through Array
	int		Modify(int nAryIndex,unsigned int nAddress,__int64 nValue,short nFlag,COLORREF clr);//According to the Waveform field index and start POS to modify the value of DATA,FLAG and COLOR 
	bool	Clear();      //Clear the data of four arrays 
	int		GetAryCount();//Get Array Bit Count

	int					BinarySearch(unsigned int nValue,int nLow,int nHigh,int nLimit);//Binary Search is used to find the array value
	int					GetBusAryByPos(unsigned int nPos);//According to Ram size index to read the array Index value of Bus

	unsigned int		GetBusPerPos(unsigned int nPos); //According to Ram size index to read the Pos value of Bus

	__int64				GetBusPerData(unsigned int nPos);//According to Ram size index to read the Data value of Bus

	short				GetBusPerFlag(unsigned int nPos);//According to Ram size index to read the Flag value of Bus

	COLORREF			GetBusPerClr(unsigned int nPos); //According to Ram size index to read Clr value of Bus


	unsigned int		GetBusPosByAry(int nAryIndex); //According to Bus array to read the Pos value of Bus

	__int64				GetBusDataByAry(int nAryIndex);//According to Bus Array to read the Data value of Bus

	short				GetBusFlagByAry(int nAryIndex);//According to Bus Array to read the Flag value of Bus
	COLORREF			GetBusClrByAry(int nAryIndex); //According to Bus Array to read the Clr value of Bus

	bool				SetBusAryPos(int nAryIndex, unsigned int nPos);//According to Bus Array Index to modify the Pos value of Bus 
	bool				SetBusAryData(int nAryIndex, __int64 nData);   //According to Bus Array Index to modify the Data value of Bus 
	bool				SetBusAryFlag(int nAryIndex, short nFlag);     //According to Bus Array Index to modify the Flag value of Bus 
	bool				SetBusAryClr(int nAryIndex,COLORREF clr);      //According to Bus Array Index to modify the Clr value of Bus 

	int					GetBusPosArySize(); //Get the size of Bus Pos Array
	int					GetBusDataArySize();//Get the size of Bus Data Array 
	int					GetBusFlagArySize();//Get the size of Bus Flag Array
	int					GetBusClrArySize(); //Get the size of Bus Clr Array

	bool				MatchLastFlag(short nFlag);//Make sure whether the last Flag accords with the flag of you input
	void                SetPid(unsigned short uPid);
};

#endif PLUGIN_BUSDTAT_ARY
