// IICSetupCustomDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IICSetupCustomDlg.h"
#include "IIC_PARAM_DATA.h" //iic paramters

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEFAULT_ADDRESS_NAME "ADDRESS"
#define DEFAULT_DATA_NAME "DATA"
#define DEFAULT_ADDRESS_BIT_COUNT 7
#define DEFAULT_DATA_BIT_COUNT 8
#define DEFAULT_READ_LEVEL 1
#define DEFAULT_ACK_LEVEL 0
/////////////////////////////////////////////////////////////////////////////
// CIICSetupCustomDlg dialog
CIICSetupCustomDlg::CIICSetupCustomDlg(int ID,CWnd* pParent /*=NULL*/)
	: CDialog(ID, pParent)
{
	//{{AFX_DATA_INIT(CIICSetupCustomDlg)
	m_bReadWriteChk = FALSE;
	m_bNackChk = FALSE;
	m_bAddressLeftShift = FALSE;
	m_bREGADDRChk = FALSE;
	//}}AFX_DATA_INIT

	m_strAddressName.Empty();
	m_strDataName.Empty();
	m_strREGADDRName.Empty();
	m_berror_flag = false;

	m_nAddressBitCount = -2;
	m_nDataBitCount = -2;
	m_nREGADDRBitCount=-2;
	m_nReadLevel = -2;
	m_nAckLevel = -2;
	m_bReadWriteActive = TRUE;
}

extern IICPARAM iicparamdata;
extern CString MessageStringTable(UINT ID);
void CIICSetupCustomDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIICSetupCustomDlg)
	DDX_Control(pDX, IDC_IIC_CUSTOM_DATA_BIT_COUNT, m_edtDataBitCount);
	DDX_Control(pDX, IDC_IIC_CUSTOM_ADDRESS_BIT_COUNT, m_edtAddressBitCount);
	DDX_Control(pDX, IDC_IIC_CUSTOM_DATA_NAME, m_edtDataName);
	DDX_Control(pDX, IDC_IIC_CUSTOM_ADDRESS_NAME, m_edtAddressName);
	DDX_Control(pDX, IDC_IIC_CUSTOM_REGADDR_BIT_COUNT, m_edtREGADDRBitCount);
	DDX_Control(pDX, IDC_IIC_CUSTOM_REGADDR_NAME, m_edtREGADDRName);
	DDX_Check(pDX, IDC_CHECK_REGADDR, m_bREGADDRChk);
	DDX_Check(pDX, IDC_IIC_CUSTOM_RW_CHK, m_bReadWriteChk);
	DDX_Check(pDX, IDC_IIC_CUSTOM_NACK_CHK, m_bNackChk);
	DDX_Check(pDX, IDC_IIC_CUSTOM_ADD_SHIFT_CHK, m_bAddressLeftShift);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIICSetupCustomDlg, CDialog)
	//{{AFX_MSG_MAP(CIICSetupCustomDlg)
	ON_BN_CLICKED(IDC_IIC_LEVEL_RH, OnIicLevelRh)
	ON_BN_CLICKED(IDC_IIC_LEVEL_RL, OnIicLevelRl)
	ON_BN_CLICKED(IDC_IIC_LEVEL_ACKH, OnIicLevelAckh)
	ON_BN_CLICKED(IDC_IIC_LEVEL_ACKL, OnIicLevelAckl)
	ON_BN_CLICKED(IDC_IIC_CUSTOM_DEFAULT, OnIicCustomDefault)
	ON_BN_CLICKED(IDC_IIC_CUSTOM_RW_CHK, OnIicCustomRwChk)
	ON_BN_CLICKED(IDC_IIC_CUSTOM_ADD_SHIFT_CHK, OnIicCustomAddShiftChk)
	ON_BN_CLICKED(IDC_IIC_CUSTOM_NACK_CHK, OnIicCustomNackChk)
	ON_BN_CLICKED(IDC_CHECK_REGADDR, OnIicCustomREGADDRChk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIICSetupCustomDlg message handlers
//void CIICSetupCustomDlg::SetI2C(IICBus* I2C)
//{

//}

BOOL CIICSetupCustomDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	InitI2CParameter();
	InitReadLevel();
	InitAckLevel();
	InitAddressItem();
	InitDataItem();
    InitREGADDRItem();
	//UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

////////////////////////////////////////////////////////////////////////////
void CIICSetupCustomDlg::InitREGADDRItem()
{
	m_strREGADDRName = iicparamdata.GetREGADDRName();
	m_nREGADDRBitCount = iicparamdata.m_nSpecNumber8;
	m_bREGADDRChk = iicparamdata.m_bSpecflag8;
	m_edtREGADDRName.SetWindowText(m_strREGADDRName);
	CString str;
	str.Format("%d",m_nREGADDRBitCount);
	m_edtREGADDRBitCount.SetWindowText(str);
	if( m_bREGADDRChk )
	{
		m_edtREGADDRName.EnableWindow();
	    m_edtREGADDRBitCount.EnableWindow();
	}
	else
	{
		m_edtREGADDRName.EnableWindow(FALSE);
	    m_edtREGADDRBitCount.EnableWindow(FALSE);
	}
	UpdateData(FALSE);
}

void CIICSetupCustomDlg::InitI2CParameter()
{
	m_strAddressName = iicparamdata.GetAddressName();
	m_nAddressBitCount = iicparamdata.AddressBitCount;
	m_strDataName = iicparamdata.GetDataName();
	m_nDataBitCount = iicparamdata.DataBitCount;
	m_nReadLevel = iicparamdata.ReadLevel;
	m_nAckLevel = iicparamdata.AckLevel;
	m_bReadWriteActive = iicparamdata.ReadWriteActive;
	m_bNackChk = iicparamdata.NackDontCare;
	m_bAddressLeftShift =iicparamdata.AddressLeftShift;		
}

void CIICSetupCustomDlg::InitReadWriteChk()
{
	m_bReadWriteActive = iicparamdata.ReadWriteActive;
}

void CIICSetupCustomDlg::InitReadLevel()
{
	CWnd* pWnd = NULL;
	CButton* pBt = NULL;
	m_bReadWriteActive = iicparamdata.ReadWriteActive;

	pWnd = GetDlgItem(IDC_IIC_CUSTOM_RW_CHK);
	pBt = (CButton*)pWnd;
	pBt->SetCheck(m_bReadWriteActive);

	int dlgID[] = {IDC_IIC_LEVEL_RL,IDC_IIC_LEVEL_RH};
	int i = 0;
	for(i = 0; i < 2; i++)
	{
		pWnd = GetDlgItem(dlgID[i]);
		pBt = (CButton*)pWnd;
		pBt->EnableWindow(m_bReadWriteActive);
		if(i == m_nReadLevel)
			pBt->SetCheck(1);
		else
			pBt->SetCheck(0);
	}

	pWnd = GetDlgItem(IDC_IIC_LEVEL_RW_RESULT);
	pBt = (CButton*)pWnd;
	pBt->EnableWindow(m_bReadWriteActive);

	CString result;
	if(m_nReadLevel == 0)
		result=MessageStringTable(IDS_WRITELOW_EN);
	else
		result=MessageStringTable(IDS_WRITEHIGH_EN);
	pWnd->SetWindowText(result);

}

void CIICSetupCustomDlg::InitAckLevel()
{
	CWnd* pWnd = NULL;
	CButton* pBt = NULL;
	int dlgID[] = {IDC_IIC_LEVEL_ACKL,IDC_IIC_LEVEL_ACKH};
	int i = 0;
	for(i = 0; i < 2; i++)
	{
		pWnd = GetDlgItem(dlgID[i]);
		pBt = (CButton*)pWnd;
		if(i == m_nAckLevel)
			pBt->SetCheck(1);
		else
			pBt->SetCheck(0);
	}

	pWnd = GetDlgItem(IDC_IIC_LEVEL_ACK_RESULT);
	pBt = (CButton*)pWnd;
	CString result;
	if(m_nAckLevel == 0)
		result=MessageStringTable(IDS_ECHOLOW_EN);
	else
		result=MessageStringTable(IDS_ECHOHIGH_EN);

	pWnd->SetWindowText(result);
	pWnd = GetDlgItem(IDC_IIC_CUSTOM_NACK_CHK);
	pBt = (CButton*)pWnd;
	if(m_bNackChk == TRUE)
		pBt->SetCheck(TRUE);
	else if(m_bNackChk == FALSE)
		pBt->SetCheck(FALSE);
}

void CIICSetupCustomDlg::InitAddressItem()
{
	CString str;
	str.Format("%d",m_nAddressBitCount);
	m_edtAddressBitCount.SetWindowText(str);
	m_edtAddressName.SetWindowText(m_strAddressName);

	CWnd* pWnd = GetDlgItem(IDC_IIC_CUSTOM_ADD_SHIFT_CHK);
	CButton* pBt = (CButton*)pWnd;
	pBt->SetCheck(m_bAddressLeftShift);
}

void CIICSetupCustomDlg::InitDataItem()
{
	CString str;
	str.Format("%d",m_nDataBitCount);
	m_edtDataBitCount.SetWindowText(str);
	m_edtDataName.SetWindowText(m_strDataName);
}

///////////////////////////////////////////////////////////////////////////

void CIICSetupCustomDlg::OnIicLevelRh() 
{
	// TODO: Add your control notification handler code here
	CString      str;
	m_nReadLevel = 1;

	CWnd* pWnd = NULL;
	CButton* pBt = NULL;

	pWnd = GetDlgItem(IDC_IIC_LEVEL_RW_RESULT);
	pBt = (CButton*)pWnd;
	str=MessageStringTable(IDS_WRITEHIGH_EN);
	pWnd->SetWindowText(str);

}

void CIICSetupCustomDlg::OnIicLevelRl() 
{
	// TODO: Add your control notification handler code here
	CString      str;
	m_nReadLevel = 0;

	CWnd* pWnd = NULL;
	CButton* pBt = NULL;

	pWnd = GetDlgItem(IDC_IIC_LEVEL_RW_RESULT);
	pBt = (CButton*)pWnd;
	str=MessageStringTable(IDS_WRITELOW_EN);
	pWnd->SetWindowText(str);

}

void CIICSetupCustomDlg::OnIicLevelAckh() 
{
	// TODO: Add your control notification handler code here
	CString    str;
	m_nAckLevel = 1;

	CWnd* pWnd = NULL;
	CButton* pBt = NULL;

	pWnd = GetDlgItem(IDC_IIC_LEVEL_ACK_RESULT);
	pBt = (CButton*)pWnd;
	str=MessageStringTable(IDS_ECHOHIGH_EN);
	pWnd->SetWindowText(str);
	
}

void CIICSetupCustomDlg::OnIicLevelAckl() 
{
	// TODO: Add your control notification handler code here
	CString   str;
	m_nAckLevel = 0;

	CWnd* pWnd = NULL;
	CButton* pBt = NULL;

	pWnd = GetDlgItem(IDC_IIC_LEVEL_ACK_RESULT);
	pBt = (CButton*)pWnd;
	str=MessageStringTable(IDS_ECHOLOW_EN);
	pWnd->SetWindowText(str);
}

void CIICSetupCustomDlg::OnIicCustomDefault() 
{
	// TODO: Add your control notification handler code here
	DefaultReadLevel();
	DefaultAckLevel();
	DefaultAddressItem();
	DefaultDataItem();
    DefaultREGADDRItem();	
}

void CIICSetupCustomDlg::DefaultREGADDRItem()
{
	m_edtREGADDRName.SetWindowText("REG ADDR");
	m_edtREGADDRBitCount.SetWindowText("8");
	m_bREGADDRChk = FALSE;
	m_edtREGADDRName.EnableWindow(FALSE);
	m_edtREGADDRBitCount.EnableWindow(FALSE);
	UpdateData(FALSE);
}

void CIICSetupCustomDlg::DefaultReadLevel()
{
	CString   str;
	m_bReadWriteActive = TRUE;

	CWnd* pWnd = GetDlgItem(IDC_IIC_CUSTOM_RW_CHK);
	CButton* pBt = (CButton*)pWnd;
	pBt->SetCheck(m_bReadWriteActive);
	

	m_nReadLevel = 1;

	int dlgID[] = {IDC_IIC_LEVEL_RL,IDC_IIC_LEVEL_RH};
	int i = 0;
	for(i = 0; i < 2; i++)
	{
		pWnd = GetDlgItem(dlgID[i]);
		pBt = (CButton*)pWnd;
		pBt->EnableWindow(m_bReadWriteActive);

		if(i == DEFAULT_READ_LEVEL)
			pBt->SetCheck(1);
		else
			pBt->SetCheck(0);
	}

	pWnd = GetDlgItem(IDC_IIC_LEVEL_RW_RESULT);
	pBt = (CButton*)pWnd;
	pBt->EnableWindow(m_bReadWriteActive);
    str=MessageStringTable(IDS_WRITEHIGH_EN);
	pWnd->SetWindowText(str);
}

void CIICSetupCustomDlg::DefaultAckLevel()
{
	CString     str;
	m_nAckLevel = 0;

	CWnd* pWnd = NULL;
	CButton* pBt = NULL;
	int dlgID[] = {IDC_IIC_LEVEL_ACKL,IDC_IIC_LEVEL_ACKH};
	int i = 0;
	for(i = 0; i < 2; i++)
	{
		pWnd = GetDlgItem(dlgID[i]);
		pBt = (CButton*)pWnd;
		if(i == DEFAULT_ACK_LEVEL)
			pBt->SetCheck(1);
		else
			pBt->SetCheck(0);
	}

	pWnd = GetDlgItem(IDC_IIC_LEVEL_ACK_RESULT);
	pBt = (CButton*)pWnd;
	str=MessageStringTable(IDS_ECHOLOW_EN);
	pWnd->SetWindowText(str);
	pWnd = GetDlgItem(IDC_IIC_CUSTOM_NACK_CHK);
	pBt = (CButton*)pWnd;
	pBt->SetCheck(FALSE);
	m_bNackChk = FALSE;
}

void CIICSetupCustomDlg::DefaultAddressItem()
{
	m_nAddressBitCount = DEFAULT_ADDRESS_BIT_COUNT;
	m_strAddressName = DEFAULT_ADDRESS_NAME;
//	m_nAddressLeftShift = FALSE;

	CString str;
	str.Format("%d",DEFAULT_ADDRESS_BIT_COUNT);
	m_edtAddressBitCount.SetWindowText(str);
	m_edtAddressName.SetWindowText(DEFAULT_ADDRESS_NAME);

	CWnd* pWnd = GetDlgItem(IDC_IIC_CUSTOM_ADD_SHIFT_CHK);
	CButton* pBt = (CButton*)pWnd;
	pBt->SetCheck(FALSE);
	m_bAddressLeftShift = FALSE;
}

void CIICSetupCustomDlg::DefaultDataItem()
{
	m_nDataBitCount = DEFAULT_DATA_BIT_COUNT;
	m_strDataName = DEFAULT_DATA_NAME;

	CString str;
	str.Format("%d",DEFAULT_DATA_BIT_COUNT);
	m_edtDataBitCount.SetWindowText(str);
	m_edtDataName.SetWindowText(DEFAULT_DATA_NAME);
}

void CIICSetupCustomDlg::OnOK() 
{
	// TODO: Add extra validation here
	StoreReadLevel();
	StoreAckLevel();
	StoreAddressItem();
	StoreDataitem();
    StoreREGADDRitem();
	if(m_strAddressName.IsEmpty())
	{
        ::SetFocus(m_edtAddressName);
		return;
	}
	else if(m_strDataName.IsEmpty())
	{
        ::SetFocus(m_edtDataName);
    	return;
	}
	else if( m_bREGADDRChk && m_strREGADDRName.IsEmpty())
	{
        ::SetFocus(m_edtREGADDRName);
    	return;
	}
	else 
		CDialog::OnOK();
}

void CIICSetupCustomDlg::StoreREGADDRitem()
{
	UpdateData();
    if( m_bREGADDRChk )
	{
		int len = m_edtREGADDRName.GetWindowTextLength();
		char* name = new char[len+1];
		m_edtREGADDRName.GetWindowText(name,len+1);
		m_strREGADDRName = name;
		delete name;
		
		len = m_edtREGADDRBitCount.GetWindowTextLength();
		char* strBitCount = new char[len+1];
		m_edtREGADDRBitCount.GetWindowText(strBitCount,len+1);
		m_nREGADDRBitCount = atoi(strBitCount);
		delete strBitCount;
		
		if(!m_strREGADDRName.IsEmpty())
			iicparamdata.SetREGADDRName(m_strREGADDRName);
		else
			AfxMessageBox(IDS_UNEMPTY);
		
		if(m_nREGADDRBitCount <= 0)
		{
			m_berror_flag = true;
		}
		else
		{
			m_berror_flag = false;
			iicparamdata.m_nSpecNumber8 = m_nREGADDRBitCount;			
		}
	}
	iicparamdata.m_bSpecflag8 = m_bREGADDRChk;
}

void CIICSetupCustomDlg::StoreReadLevel()
{
	//Read item
	iicparamdata.ReadWriteActive = m_bReadWriteActive;
	iicparamdata.ReadLevel = m_nReadLevel;
}

void CIICSetupCustomDlg::StoreAckLevel()
{
	//Ack item 
	iicparamdata.AckLevel = m_nAckLevel;
	iicparamdata.NackDontCare = m_bNackChk ;
}

void CIICSetupCustomDlg::StoreAddressItem()
{	
	int len = m_edtAddressName.GetWindowTextLength();
	char* name = new char[len+1];
	m_edtAddressName.GetWindowText(name,len+1);
	m_strAddressName = name;
	delete name;
	
	len = m_edtAddressBitCount.GetWindowTextLength();
	char* strBitCount = new char[len+1];
	m_edtAddressBitCount.GetWindowText(strBitCount,len+1);
	m_nAddressBitCount = atoi(strBitCount);
	delete strBitCount;
	
	if(!m_strAddressName.IsEmpty())
		iicparamdata.SetAddressName(m_strAddressName);
	else
		AfxMessageBox(IDS_UNEMPTY);
	
	if(m_nAddressBitCount <= 0)
	{
		m_berror_flag = true;
	}
	else
	{
		m_berror_flag = false;
		iicparamdata.AddressBitCount = m_nAddressBitCount;
		iicparamdata.AddressLeftShift = m_bAddressLeftShift;
	}

}

void CIICSetupCustomDlg::StoreDataitem()
{
	
	int len = m_edtDataName.GetWindowTextLength();
	char* name = new char[len+1];
	m_edtDataName.GetWindowText(name,len+1);
	m_strDataName = name;
	delete name;

	len = m_edtDataBitCount.GetWindowTextLength();
	char* strBitCount = new char[len+1];
	m_edtDataBitCount.GetWindowText(strBitCount,len+1);
	m_nDataBitCount = atoi(strBitCount);
	delete strBitCount;

	//Data item
	if(!m_strDataName.IsEmpty())
		iicparamdata.SetDataName(m_strDataName);
	else
		AfxMessageBox(IDS_UNEMPTY);

 	 if(m_nDataBitCount <= 0)
		 m_berror_flag = true;
	 else
	 {
		m_berror_flag = false;
		iicparamdata.DataBitCount = m_nDataBitCount;
	 }
}
void CIICSetupCustomDlg::OnIicCustomRwChk() 
{
	// TODO: Add your control notification handler code here
	CWnd* pWnd = GetDlgItem(IDC_IIC_CUSTOM_RW_CHK);
	CButton* pBt = (CButton*)pWnd;
	m_bReadWriteActive = pBt->GetCheck();

	pWnd = GetDlgItem(IDC_IIC_CUSTOM_RW_CHK);
	pBt = (CButton*)pWnd;
	pBt->SetCheck(m_bReadWriteActive);

	int dlgID[] = {IDC_IIC_LEVEL_RL,IDC_IIC_LEVEL_RH};
	int i = 0;
	for(i = 0; i < 2; i++)
	{
		pWnd = GetDlgItem(dlgID[i]);
		pBt = (CButton*)pWnd;
		pBt->EnableWindow(m_bReadWriteActive);
		if(i == m_nReadLevel)
			pBt->SetCheck(1);
		else
			pBt->SetCheck(0);
	}

	pWnd = GetDlgItem(IDC_IIC_LEVEL_RW_RESULT);
	pBt = (CButton*)pWnd;
	pBt->EnableWindow(m_bReadWriteActive);

}

void CIICSetupCustomDlg::OnIicCustomAddShiftChk() 
{
	// TODO: Add your control notification handler code here
	CWnd* pWnd = GetDlgItem(IDC_IIC_CUSTOM_ADD_SHIFT_CHK);
	CButton* pBt = (CButton*)pWnd;
	if( pBt->GetCheck() == TRUE)
		m_bAddressLeftShift = TRUE;
	else
		m_bAddressLeftShift = FALSE;
}

void CIICSetupCustomDlg::OnIicCustomNackChk() 
{
	// TODO: Add your control notification handler code here
	CWnd *pWnd = GetDlgItem(IDC_IIC_CUSTOM_NACK_CHK);
	CButton *pBt = (CButton*)pWnd;

	if( pBt->GetCheck() == TRUE)
		m_bNackChk = TRUE;
	else 
		m_bNackChk = FALSE;
}

void CIICSetupCustomDlg::OnIicCustomREGADDRChk()
{
	UpdateData();
    if( m_bREGADDRChk )
	{
		m_edtREGADDRName.EnableWindow();
	    m_edtREGADDRBitCount.EnableWindow();
		m_edtAddressName.SetWindowText("SLAVE ADDR");
	}
	else
	{
		m_edtREGADDRName.EnableWindow(FALSE);
	    m_edtREGADDRBitCount.EnableWindow(FALSE);
		m_edtAddressName.SetWindowText(DEFAULT_ADDRESS_NAME);
	}
}