// PlugIIC.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "PlugIIC.h"
#include "HTPara1.h"
#include "BusData.h"
#include "BPOParamters.h"
extern HTPara	htdata;
extern DATABUSHEADER hdr;

#define  LABEL_DATA	4001 //Filter the packet, which will correspond to the Flag in the busdata.cpp. 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CPlugIICApp
#define PLUG_API __declspec(dllexport)
CPlugIICApp theApp;

DATATOOLBAR Unit[1]=
{
	ID_BUTTON_DATA, IDB_PLUGIN_DATA, 0,"DATA", false,0
};//ID_BUTTON_DATA is defined in the Resource.h	


// ********************************************************************************
// These need to be changed by different DLLs toi use there own buttons and bitmaps
UINT		m_nID_BUTTON=0;
UINT		m_nID_BITMAP=0;
// ********************************************************************************

// Exported Plug-In methods
extern "C" PLUG_API UINT InitPlugIn(CTrueColorToolBar *pwndToolbar,int sort,char *szTooltip,bool &type,int& ButtonState);
extern "C" PLUG_API void DestroyPlugIn();
extern "C" PLUG_API bool PlugInEventHandler (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
extern "C" PLUG_API void GetPlugInResources(HICON *hIcon, CString *szLabel);
extern "C" PLUG_API void GetPlugInName(char *szPlugInName);
extern "C" PLUG_API bool GetFiltrateFormat(UINT nID,short &Flag);
extern CBPOParamters *pBPOParameters;
bool		 JudgeCommand(UINT nID);	//
bool		 m_bCurToolBarCheck;
// Used to get the name of the Plug-In
PLUG_API void GetPlugInName(char *szPlugInName)
{
	strcpy(szPlugInName, hdr.specialid);
}

// Used to initialize the Plug-In and various resources
PLUG_API UINT InitPlugIn(CTrueColorToolBar *pwndToolBar,int sort,char *szTooltip,bool &type,int& ButtonState)
{
#ifdef DEBUG
	TRACE("Called DLL's InitPlugIn() method\n");
#endif
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	m_nID_BUTTON=Unit[sort].Command;
	m_nID_BITMAP=Unit[sort].Bitmap;
	strcpy(szTooltip,Unit[sort].Tooltip);
	type=Unit[sort].bTwostep;
	theApp.SetToolBarPointer(pwndToolBar);
	theApp.AddButtonToToolBar();
#ifdef DEBUG
	TRACE("Plug_In_1_Funtion_INIT_PLUG_IN() called...\n");
#endif

	return m_nID_BUTTON;
}

// Used to destroy the Plug-In and free resources help by it
PLUG_API void DestroyPlugIn()
{
#ifdef DEBUG
	TRACE("Called DLL's DestroyPlugIn() method\n");
#endif

	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	theApp.RemoveButtonFromToolBar();

#ifdef DEBUG
	TRACE("Plug_In_1_Funtion_DESTROY_PLUG_IN() called...\n");
#endif
}

// Event handler function. Redirects call to CPlug_In_1App::OnCmdMsg()
PLUG_API bool PlugInEventHandler (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
#ifdef DEBUG
	TRACE("Called DLL's PlugInEventHandler() method\n");
#endif

	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if (JudgeCommand(nID))
		theApp.SendCmdMsgToPlugIn(nID, nCode, pExtra, pHandlerInfo);

	return true;
}

// Used to get the various resources from the Plug-In. Not used till now.
PLUG_API void GetPlugInResources(HICON *hIcon, CString *szLabel)
{
	hIcon = theApp.GetPlugInIcon();
	*szLabel = "Plug-In 1 Icon";
}

BEGIN_MESSAGE_MAP(CPlugIICApp, CWinApp)
	//{{AFX_MSG_MAP(CPlugIICApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlugIICApp construction

CPlugIICApp::CPlugIICApp():CWinApp(_T("PlugIIC"))
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_pwndToolBar = NULL;	
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPlugIICApp object


/////////////////////////////////////////////////////////////////////////////
CPlugIICApp::~CPlugIICApp()
{
	// TODO: Add your specialized code here and/or call the base class
#ifdef DEBUG
	TRACE("Called CPlugIICApp::~CPlugIICApp() method\n");
#endif

	// Remove button added by this DLL from the main app's default toolbar
//	RemoveButtonFromToolBar();

	// Set toolbar pointer to point to NULL;
	m_pwndToolBar = NULL;
}

// CPlug_In_1App initialization
BOOL CPlugIICApp::InitInstance()
{
#ifdef DEBUG
	TRACE("Called CPlug_In_1App::InitInstance() method\n");
#endif

	CWinApp::InitInstance();

	return TRUE;
}

// Used to set the toolbar object pointer
void CPlugIICApp::SetToolBarPointer(CTrueColorToolBar *pwndToolBar)
{
#ifdef DEBUG
	TRACE("Called CPlugIICApp::SetToolBarpointer() method\n");
#endif

	m_pwndToolBar = pwndToolBar;
}

// Used to add button to main app's toolbar
void CPlugIICApp::AddButtonToToolBar()
{
#ifdef DEBUG
	TRACE("Called CPlugIICApp::AddButtonToToolBar() method\n");
#endif

	CToolBarCtrl& pToolbarCtrl = m_pwndToolBar->GetToolBarCtrl();
//	ASSERT(pToolbarCtrl != NULL);

	// Get the number of buttons in existing 
	// toolbar control.
	int nButCount = pToolbarCtrl.GetButtonCount();

	// Add a new button in it. 
	// IDB_NEW_BUTTON is a bitmap resource
	int nImageCount = pToolbarCtrl.AddBitmap(1, m_nID_BITMAP);

	// get the number of images in existing toolbar
//	int nImageCount = pToolbarCtrl.GetImageList()->GetImageCount();

	// Define a new button
	TBBUTTON tb;

	// Index of new button image.
	tb.iBitmap = nImageCount;

	// Command associated with toolbar button
	tb.idCommand = m_nID_BUTTON;

	// Setting button state
	if (m_bCurToolBarCheck)//It indicates that it is the second-order and can be pressed, the state of the toolbar can be decided through the Bus Parameters. 
	{	
		tb.fsState = TBSTATE_ENABLED|TBSTATE_CHECKED;		
	}
	else	
		tb.fsState = TBSTATE_ENABLED;

	// Setting button style
	tb.fsStyle = TBSTYLE_BUTTON;
	tb.dwData = 0;
	tb.iString = NULL;

	// Insert it in existing toolbar control
		TRACE ("BUTTON ID: %d\n", m_nID_BUTTON);
		TRACE ("BUTTON BITMAP: %d\n", tb.iBitmap);
	pToolbarCtrl.InsertButton(nButCount, &tb);
}

// Used to remove button from main app's toolbar
void CPlugIICApp::RemoveButtonFromToolBar()
{
#ifdef DEBUG
	TRACE("Called CPlugIICApp::RemoveButtonFromToolBar() method\n");
#endif

	if (m_pwndToolBar != NULL)
	{
		CToolBarCtrl& pToolbarCtrl = m_pwndToolBar->GetToolBarCtrl();

		TBBUTTON tbButton;

		int nButtonCount = pToolbarCtrl.GetButtonCount();
		// Get info for the button added by this DLL
		for (int i=0; i<nButtonCount; ++i)
		{
			pToolbarCtrl.GetButton(i, &tbButton);
			
			if (JudgeCommand(tbButton.idCommand))
			{
				TRACE ("BUTTON ID: %d\n", tbButton.idCommand);
				TRACE ("BUTTON BITMAP: %d\n", tbButton.iBitmap);

				if (pToolbarCtrl.DeleteButton(i) == 0)
				{
	#ifdef DEBUG
					TRACE("ERROR: Toolbar button NOT deleted\n");
	#endif
				}
				else
				{
	#ifdef DEBUG
					TRACE("Toolbar button deleted\n");
	#endif
				}
			}
		}
	}
}

int CPlugIICApp::ExitInstance()
{
	// TODO: Add your specialized code here and/or call the base class
#ifdef DEBUG
	TRACE("Called CPlug_In_1App::ExitInstance() method\n");
#endif

	return CWinApp::ExitInstance();
}

// Used by main app to get info about the button added my this DLL
UINT CPlugIICApp::GetToolBarButtonInfo(void)
{
#ifdef DEBUG
	TRACE("Called CPlug_In_1App::GetToolBarButtonInfo() method\n");
#endif
	return m_nID_BUTTON;
}

void CPlugIICApp::SendCmdMsgToPlugIn(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
#ifdef DEBUG
	TRACE("Called CPlug_In_1App::SendCmdMsgToPlugIn() method\n");
#endif

	OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

BOOL CPlugIICApp::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
#ifdef DEBUG
	TRACE("Called CPlug_In_1App::OnCmdMsg() method\n");
#endif	
	int a=pBPOParameters->m_pAddressAry->GetSize();	
	// TODO: Add your specialized code here and/or call the base class
	return CWinApp::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

// Used to get the handle to the icon dor the Plug-In
HICON *CPlugIICApp::GetPlugInIcon(void)
{
	return NULL;
}
// Get the Flag of the Packet which needs to be filtered. 
PLUG_API bool GetFiltrateFormat(UINT nID,short &Flag)
{	
	switch(nID)
	{
	case ID_BUTTON_DATA:
		Flag=LABEL_DATA;
		break;	
	default:
		{
			Flag=-1;			
			return false;
		}		
	}	
	return true;	
}
/////////////////////////////////////////////////////////////////////////////
// The one and only CPlugIICApp object
//Judge which the ID is and press.  
bool JudgeCommand(UINT nID)
{	
	int sum=1;//Unit Sum.
	unsigned int command=0;
	for (int i=0;i<sum;i++)
	{
		command=Unit[i].Command;
		if (nID==command)
			return true;			
	}
	return false;
}